﻿using System.Linq.Expressions;
using System.Reflection;
using NHibernate.Hql.Ast;
using NHibernate.Linq.Functions;
using NHibernate.Linq.Visitors;
using NHibernate.Util;
using NodaTime;

namespace Drive.Common.Data.DialectExtensions
{
    public class LocalDatePropertiesHqlGenerator : BaseHqlGeneratorForProperty
    {
        public LocalDatePropertiesHqlGenerator()
        {
            SupportedProperties = new[]
            {
                ReflectHelper.GetProperty((LocalDate x) => x.Year),
                ReflectHelper.GetProperty((LocalDate x) => x.Month),
                ReflectHelper.GetProperty((LocalDate x) => x.Day),
            };
        }

        public override HqlTreeNode BuildHql(MemberInfo member, Expression expression, HqlTreeBuilder treeBuilder, IHqlExpressionVisitor visitor)
        {
            return treeBuilder.MethodCall(member.Name.ToLowerInvariant(),
                                          visitor.Visit(expression).AsExpression());
        }
    }
}
