﻿using NHibernate.Mapping.ByCode;
using NodaTime;

namespace Drive.Common.Data
{
    public class TypeConventions
    {
        public static ConventionModelMapper LocalTimeConvention
        {
            get
            {
                var mapper = new ConventionModelMapper();
                mapper.IsProperty((info, b) => b || info.GetPropertyOrFieldType() == typeof(LocalTime));
                mapper.BeforeMapProperty +=
                       (inspector, member, customizer) =>
                       {
                           if (member.LocalMember.GetPropertyOrFieldType() == typeof(LocalTime))
                               customizer.Type<LocalTimeType>();
                       };

                return mapper;
            }
        }
    }
}
