﻿using Microsoft.Extensions.Options;

namespace Drive.Common.Email
{
    public class PickupEmailSender :
        ISendEmail
    {
        private readonly EmailOptions _options;

        public PickupEmailSender(
            IOptions<EmailOptions> options)
        {
            _options = options.Value;
        }

        public async Task Send(
            EmailRequest request)
        {
            string path = Path.Combine(_options.PickupDirectory!, Guid.NewGuid().ToString() + ".eml");

            using StreamWriter outputFile = new(path);

            await outputFile.WriteAsync(request.Content);
        }
    }
}
