﻿using NServiceBus.MessageMutator;

namespace Drive.Common.Messaging.Mutator
{
    public class CorrelationIdsMessageMutator
        : IMutateOutgoingTransportMessages
    {
        public Task MutateOutgoing(MutateOutgoingTransportMessageContext context)
        {
            if (context.TryGetIncomingHeaders(out var incomingHeaders))
            {
                if (incomingHeaders.ContainsKey(HeaderConstants.CORRELATION_ID_HEADER_KEY))
                {
                    string correlationId = incomingHeaders[HeaderConstants.CORRELATION_ID_HEADER_KEY];
                    context.OutgoingHeaders.Add(HeaderConstants.CORRELATION_ID_HEADER_KEY, correlationId);
                }
            }

            return Task.CompletedTask;
        }
    }
}