﻿namespace Drive.Common.Messaging.Signing
{
    public static class RegisterBehaviors
    {
        public static void RegisterSigningBehaviors(this EndpointConfiguration configuration)
        {
            configuration.Pipeline
                .Register(MessageSigningBehavior.StepId, typeof(MessageSigningBehavior), "Signs outgoing messages with a cryptographic signature");
            configuration.Pipeline
                .Register(typeof(SignatureVerificationBehavior), "Validates the cryptographic signature on incoming messages");

            configuration.Recoverability()
                .AddUnrecoverableException<MessageSignatureException>();
        }
    }
}
