﻿
namespace Drive.Common.Query
{
    /// <summary>
    /// Base interface for query handlers
    /// </summary>
    /// <typeparam name="TParameter">Query type</typeparam>
    /// <typeparam name="TResult">Query Result type</typeparam>
    public interface IQueryHandler<in TParameter, out TResult>
    {
        /// <summary>
        /// Retrieve a query result from a query
        /// </summary>
        /// <param name="query">Query</param>
        /// <returns>Retrieve Query Result</returns>
        TResult Retrieve(TParameter query);
    }

    /// <summary>
    /// Base interface for query handlers
    /// </summary>
    public interface IQueryHandler<out TResult>
    {
        /// <summary>
        /// Retrieve a query result from a query
        /// </summary>
        /// <returns>Retrieve Query Result</returns>
        TResult Retrieve();
    }
}
