﻿using Drive.Common.Security.Token;
using Lamar;
using Microsoft.AspNetCore.Authentication.JwtBearer;
using Microsoft.Extensions.Options;

namespace Drive.Common.Security
{
    public class SecurityRegistry
        : ServiceRegistry
    {
        public SecurityRegistry()
        {
            For<ITokenStorage>().Use<TokenStorage>();
            For<ISecurityKeyResolver>().Use<DiscoveryDocumentSecurityKeyResolver>();

            For<ITokenValidator>().Use(x =>
            {
                ISecurityKeyResolver keyResolver = x.TryGetInstance<ISecurityKeyResolver>();
                IOptionsMonitor<JwtBearerOptions> options = x.TryGetInstance<IOptionsMonitor<JwtBearerOptions>>();

                JwtTokenValidator validator = new(
                    options,
                    keyResolver);

                return validator;
            });
        }
    }
}
