﻿using Microsoft.AspNetCore.Mvc.ModelBinding;

namespace Drive.Common.Web.Extensions
{
    public static class DictionaryExtensions
    {
        public static ModelStateDictionary MapToModelState(
            this IDictionary<string, IEnumerable<string>> validationErrors,
            ModelStateDictionary modelState)
        {
            foreach (string key in validationErrors.Keys)
            {
                if (validationErrors[key].Any())
                {
                    foreach (string error in validationErrors[key])
                        modelState.AddModelError(key, error);
                }
            }

            return modelState;
        }
    }
}
