﻿using NServiceBus.MessageRouting.RoutingSlips;

namespace Drive.Common.Web.Extensions
{
    public static class MessageSessionExtensions
    {
        public static Task Route(this IMessageSession bus, object message, SendOptions sendOptions, params string[] destinations)
        {
            sendOptions = EnrichSendOptions(Guid.NewGuid(), sendOptions, destinations);
            return bus.Send(message, sendOptions);
        }

        private static SendOptions EnrichSendOptions(Guid routingSlipId, SendOptions sendOptions, string[] destinations)
        {
            RoutingSlip routingSlip = new(routingSlipId, destinations);
            ProcessingStep processingStep = routingSlip.Itinerary.First();
            string value = System.Text.Json.JsonSerializer.Serialize(routingSlip);
            sendOptions.SetHeader("NServiceBus.MessageRouting.RoutingSlips.Router", value);
            sendOptions.SetDestination(processingStep.Address);

            return sendOptions;
        }
    }
}
