﻿using System.Reflection;

namespace Drive.Common
{
    public class AssemblyLoader
    {
        public static IEnumerable<Assembly> LoadAssemblies(string path, params string[] assemblies)
        {
            var results = new List<Assembly>();

            foreach (var assemblyName in assemblies)
            {
                var assemblyPath = Path.GetFullPath(Path.Combine(path, assemblyName));
                results.Add(Assembly.LoadFrom(assemblyPath));
            }

            return results;
        }
    }
}