﻿using System.Text.Json;
using Newtonsoft.Json;
using NodaTime;
using NodaTime.Serialization.JsonNet;
using NodaTime.Serialization.SystemTextJson;

namespace Drive.Common
{
    public static class DriveSerialization
    {
        public static readonly JsonSerializerOptions Options;
        public static readonly JsonSerializerSettings Settings;

        static DriveSerialization()
        {
            Options = new(JsonSerializerDefaults.General);
            Options.ConfigureForNodaTime(DateTimeZoneProviders.Tzdb);
            Options.PropertyNamingPolicy = JsonNamingPolicy.CamelCase;
            Options.DictionaryKeyPolicy = JsonNamingPolicy.CamelCase;

            Settings = new();
            Settings.ConfigureForNodaTime(DateTimeZoneProviders.Tzdb);
        }
    }
}
