﻿namespace Drive.Common.Extensions
{
    public static partial class EnumerablExtensions
    {
        public static bool DoesNotContain<TSource>(this IEnumerable<TSource> source, TSource value)
        {
            return !source.Contains(value);
        }

        public static bool ContainsAll<TSource>(this IEnumerable<TSource> source, IEnumerable<TSource> value)
        {
            return !value.Except(source).Any();
        }
    }
}
