﻿namespace Drive.Common
{
    public interface ISendEmail
    {
        Task Send(EmailRequest request);
    }

    public class EmailRequest
    {
        public string From { get; set; } = string.Empty;
        public IEnumerable<string> To { get; set; } = [];
        public IEnumerable<string> Cc { get; set; } = [];
        public string Subject { get; set; } = string.Empty;
        public string Content { get; set; } = string.Empty;
        public IEnumerable<Attachment> Attachments { get; set; } = [];
        public string? AccessToken { get; set; }

        public class Attachment
        {
            public string Name { get; set; } = string.Empty;
            public byte[] Content { get; set; } = [];
            public string ContentId { get; set; } = string.Empty;
            public string ContentType { get; set; } = string.Empty;
            public bool Inline { get; set; }
        }
    }
}
