﻿using Drive.Common.Data;
using FluentAssertions;
using NHibernate.Engine;
using NodaTime;
using Xunit;

namespace Drive.Common.UnitTest
{
    public class LocalDateTypeSuite
    {
        [Fact]
        public void should_convert_to_sql_string_correctly()
        {
            //arrange
            LocalDate date = new(2015, 11, 25);

            //act
            var sqlString = new LocalDateType().ObjectToSQLString(date, new DriveMsSql2012Dialect());

            //assert
            sqlString.Should().Be("yyyyMMdd");
        }

        [Fact]
        public void should_convert_to_string_correctly()
        {
            //arrange
            LocalDate date = new(2015, 11, 25);

            //act
            var sqlString = new LocalDateType().ToLoggableString(date, (ISessionFactoryImplementor)null!);

            //assert
            sqlString.Should().Be("yyyyMMdd");
        }
    }
}