﻿using Drive.Common.Command;
using Lamar;
using Xunit;

namespace Drive.Common.Web.UnitTest.Command
{
    public class SomeCommand
    {
        public Guid Id { get; set; }
    }

    public class SomeCommandValidator
        : ICommandValidator<SomeCommand>
    {
        public IDictionary<string, IEnumerable<string>> Validate(SomeCommand command)
        {
            return new Dictionary<string, IEnumerable<string>>();
        }
    }

    public class CommandDispatcherSuite
    {
        [Fact]
        public void make_generic()
        {
            var container = new Container(x =>
            {
                x.Scan(scan =>
                {
                    scan.TheCallingAssembly();
                    scan.WithDefaultConventions();

                    scan.ConnectImplementationsToTypesClosing(typeof(ICommandValidator<>));
                });
            });

            SomeCommand command = new SomeCommand { Id = Guid.NewGuid() };
            Type validatorType = typeof(ICommandValidator<>).MakeGenericType(command.GetType());

            var result = container.GetAllInstances(validatorType);
            foreach (var validator in result)
            {
                var validationResult = ((dynamic)validator).Validate(command);
            }
        }
    }
}
